//
// EnvisionAsset.swift
//
// Generated by openapi-generator
// https://openapi-generator.tech
//

import Foundation
#if canImport(AnyCodable)
import AnyCodable
#endif

public struct EnvisionAsset: Codable, JSONEncodable, Hashable {

    public var id: Int?
    public var listingKey: String?
    public var aboundId: String?
    public var thumbnail: String?
    public var topDown: String?
    public var glb: String?
    public var obj: String?
    public var dump: String?
    public var tags: AnyCodable?
    public var updatedAt: Date?
    public var createdAt: Date?
    public var property: Property?
    public var landmarks: [Landmark]?

    public init(id: Int? = nil, listingKey: String? = nil, aboundId: String? = nil, thumbnail: String? = nil, topDown: String? = nil, glb: String? = nil, obj: String? = nil, dump: String? = nil, tags: AnyCodable? = nil, updatedAt: Date? = nil, createdAt: Date? = nil, property: Property? = nil, landmarks: [Landmark]? = nil) {
        self.id = id
        self.listingKey = listingKey
        self.aboundId = aboundId
        self.thumbnail = thumbnail
        self.topDown = topDown
        self.glb = glb
        self.obj = obj
        self.dump = dump
        self.tags = tags
        self.updatedAt = updatedAt
        self.createdAt = createdAt
        self.property = property
        self.landmarks = landmarks
    }

    public enum CodingKeys: String, CodingKey, CaseIterable {
        case id
        case listingKey = "ListingKey"
        case aboundId
        case thumbnail
        case topDown
        case glb
        case obj
        case dump
        case tags
        case updatedAt
        case createdAt
        case property = "Property"
        case landmarks = "Landmarks"
    }

    // Encodable protocol methods

    public func encode(to encoder: Encoder) throws {
        var container = encoder.container(keyedBy: CodingKeys.self)
        try container.encodeIfPresent(id, forKey: .id)
        try container.encodeIfPresent(listingKey, forKey: .listingKey)
        try container.encodeIfPresent(aboundId, forKey: .aboundId)
        try container.encodeIfPresent(thumbnail, forKey: .thumbnail)
        try container.encodeIfPresent(topDown, forKey: .topDown)
        try container.encodeIfPresent(glb, forKey: .glb)
        try container.encodeIfPresent(obj, forKey: .obj)
        try container.encodeIfPresent(dump, forKey: .dump)
        try container.encodeIfPresent(tags, forKey: .tags)
        try container.encodeIfPresent(updatedAt, forKey: .updatedAt)
        try container.encodeIfPresent(createdAt, forKey: .createdAt)
        try container.encodeIfPresent(property, forKey: .property)
        try container.encodeIfPresent(landmarks, forKey: .landmarks)
    }
}

